// 
{*******************************************************}
{                                                       }
{                E L E K S   W I Z A R D S              }        
{                                                       }
{        Copyright (C) 1998, 1999 Eleks Software        }
{               Created by Yuri Solodkiy                }
{                                                       }
{                 http://eleks.txnet.com                }
{                    eleks@txnet.com                    }
{                   gerasika@yahoo.com                  }                            
{                                                       }
{*******************************************************}


// $Archive: /H/Gerix/Projects/elWizards/elWizards.pas $ $Author: Gerix $ $Date: 19.08.99 12:49 $ $Revision: 9 $ $Workfile: elWizards.pas $

unit elWizards;

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, elWizardsPage;

type
  TelWizard = class(TForm)
    PSys: TPanel;
    BottomPanel: TPanel;
    Bevel: TBevel;
    BBack: TButton;
    BNext: TButton;
    BCancel: TButton;
    Place: TPanel;
    Pages: TelWizardPageList;
    WizardStartPage: TelWizardPage;
    procedure BNextClick(Sender: TObject);
    procedure BBackClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
{  }
  protected
    Joined: boolean;
    MasterWizard: TelWizard;
    procedure Notification(Comp: TComponent; Op: TOperation); override;
    procedure DoCancel(var Allow: boolean); virtual;
    procedure CreateWizard;
  public
    constructor Create(theOwner: TComponent); override;
    destructor Destroy; override;
    procedure Finish;
    procedure Validate;
    procedure ShowModal(const Do_Not_UseShowModal_Use_Start_Method_Instead);
    procedure UpdateButtons;
    function Start(Start_Page_Or_NIL: TelWizardPage): TModalResult;
    procedure Join(W: TelWizard; AfterPage: TelWizardPage; BeforePage: TelWizardPage);
    property CurrentPage: TelWizardPage read FCurrentPage write SetCurrentPage;
    property NextPage: TelWizardPage read GetNextPage write SetNextPage;
    property BackPage: TelWizardPage read GetBackPage write SetBackPage;
    property PageCount: integer read GetPageCount;
    property Page[Index: integer]: TelWizardPage read GetPages;
    property OnCancel: TNotifyEvent read FOnCancel write FOnCancel;
    property OnFinish: TNotifyevent read FOnFinish write FOnFinish;
  public
    function GetBackButtonName: string; virtual;
    function GetFinishButtonName: string; virtual;
    function GetNextButtonName: string; virtual;
    function GetCancelButtonName: string; virtual;
  published
    property Caption: string read FCaption write SetCaption;
  end;

  TelWizardClass = class of TelWizard;

{  }

implementation

{$R *.DFM}

{  }

// THIS IS DUMMY CODE NEEDED FOR DELPHI FORM DESIGNER. TRUE CODE IS IN PACKAGE

procedure TelWizard.BNextClick(Sender: TObject);
begin
  ;
end;

procedure TelWizard.BBackClick(Sender: TObject);
begin
  ;
end;

procedure TelWizard.FormShow(Sender: TObject);
begin
  ;
end;

procedure TelWizard.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  ;
end;

end.

